<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>JFLAP: Mealy Machines</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070710;16051700">
	<META NAME="CHANGED" CONTENT="20070710;16142300">
	<!--@author Jinghui Lim-->
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Mealy Machines</H1>
<H2>Contents</H2>
<P><A HREF="#definition">Definition</A><BR><A HREF="#differences">Differences
between a Mealy Machine and an FA</A> 
</P>
<UL>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#finalState">No Final
	State</A> 
	</P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#transitionOutput">Transition
	Output</A> 
	</P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#producingOutput">Producing
	Output from an Input String</A> 
	</P>
	<LI><P><A HREF="#nondeterminism">No Nondeterminism</A> 
	</P>
</UL>
<P><A HREF="mealyExamples.html">Proceed to Mealy Machine Examples</A></P>
<H2><A NAME="definition"></A>Definition</H2>
<P>JFLAP defines a Mealy machine <I>M</I> as the sextuple <I>M</I> =
(<I>Q</I>, Σ<!--capital sigma-->, Γ<!--capital gamma-->, δ<!--small delta-->,
ω<!--small omega-->, <I>q<SUB>s</SUB></I>) where 
</P>
<P><I>Q</I> is a finite set of states {<I>q<SUB>i</SUB></I> | <I>i</I>
is a nonnegative integer} <BR>Σ<!--capital sigma--> is the finite
input alphabet <BR>Γ<!--capital gamma--> is the finite output
alphabet <BR>δ<!--small delta--> is the transition function, δ<!--small --><!--delta-->
: <I>Q</I> &times;<!--times--> Σ<!--capital sigma--> →<!--right arrow-->
<I>Q</I> <BR>ω<!--small omega--> denotes the output function, ω<!--small --><!--omega-->
: <I>Q</I> &times;<!--times--> Σ<!--capital sigma--> →<!--right arrow-->
Γ<!--capital gamma--> <BR><I>q<SUB>s</SUB></I> (is a member of<!--&#8712;--><!--element of-->
<I>Q</I>) is the initial state 
</P>
<P>Mealy machines are different than <A HREF="mooreMachines.html">Moore
machines</A> in the output function, ω<!--small omega-->. In a Mealy
machine, output is produced by its transitions, while in a Moore
machine, output is produced by its states. 
</P>
<P>To start a new Mealy machine, select the <B>Mealy Machine</B>
option from the main menu. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealySelection.png" NAME="Graphic1" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Starting a new Mealy machine 
</P>
<H2><A NAME="differences"></A>Differences between a Mealy Machine and
an FA</H2>
<P>A Mealy machine is very similar to a <A HREF="../fa/fa.html">Finite
Automaton</A> (FA), with a few key differences: 
</P>
<UL>
	<LI><P STYLE="margin-bottom: 0in">It has <A HREF="#finalState">no
	final states</A>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">Its <A HREF="#transitionOutput">transitions
	produce output</A>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">It does not accept or reject
	input, instead, it <A HREF="#producingOutput">generates output from
	input</A>. 
	</P>
	<LI><P>Lastly, Mealy machines <A HREF="#nondeterminism">cannot have
	nondeterministic states</A>. 
	</P>
</UL>
<P>Let's go through these points. 
</P>
<H3><A NAME="finalState"></A>No Final State</H3>
<P>In an FA, when you have the Attribute Editor tool selected (you
may do so by clicking the 
<IMG SRC="images/arrow.gif" NAME="Graphic2" ALIGN=BOTTOM BORDER=0>
button), right-clicking on a state it will produce a pop-up menu that
allows you to, among other things, set it to be a final state. In a
Mealy machine, that option is not available. 
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TD>
				<P ALIGN=CENTER><IMG SRC="images/FSAStateMenu.png" NAME="Graphic3" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P ALIGN=CENTER><IMG SRC="images/mealyStateMenu.png" NAME="Graphic4" ALIGN=BOTTOM BORDER=0></P>
			</TD>
		</TR>
		<TR>
			<TD>
				<P ALIGN=CENTER>An FA state menu</P>
			</TD>
			<TD>
				<P ALIGN=CENTER>A Mealy machine state menu</P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P>A Mealy machine does not have final states because it does not
accept or reject input. Instead, each transition produces output,
which will be described below. 
</P>
<H3><A NAME="transitionOutput"></A>Transition Output</H3>
<P>A Mealy machine produces output each time it takes a transition. 
</P>
<P>Creating a Mealy machine is the same as creating an FA with the
exception of creating its transitions. In a Mealy machine, each
transition produces output. When you are creating a transition, two
blanks appear instead of one. The first blank is for the input
symbol, the second blank is for the output symbol. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyTransitionCreate.jpg" NAME="Graphic5" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Creating a transition 
</P>
<P>When the transition is created, its label will be two symbols
separated by a semicolon, &quot;;&quot;. The input symbol is to the
left of the semicolon, and the output symbol is to its right. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyTransitionDone.jpg" NAME="Graphic6" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Transtion created 
</P>
<P>Thus, when in <I>q</I><SUB>0</SUB> with input of &quot;1&quot;,
the machine will take the transition to <I>q</I><SUB>1</SUB> and
produce the output &quot;0&quot;. 
</P>
<P>With each transition producing output, the Mealy machine can
produce output from an input string. 
</P>
<H3><A NAME="producingOutput"></A>Producing Output from an Input
String</H3>
<P>Instead of accepting or rejecting input, a Mealy machine produces
output from an input string. 
</P>
<P>Let's look at this simple Mealy machine, which can be downloaded
through <A HREF="files/mealyNOT.jff">mealyNOT.jff</A>: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyNOT.png" NAME="Graphic7" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>A simple Mealy machine 
</P>
<P>When we select the menu option <B>Input : Step...</B> and enter
your input, we get a display similar to that of an FA, except with
another piece of tape below the input tape. This displays the output
of the machine at the current step. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyOutputDisplay.jpg" NAME="Graphic8" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>The output display 
</P>
<P>At each step. The output tape updates itself to display the total
output that has been produced so far: 
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TD>
				<P>Initial:</P>
			</TD>
			<TD>
				<P>Step 1:</P>
			</TD>
			<TD>
				<P>Step 2:</P>
			</TD>
			<TD>
				<P><B>. . . </B>
				</P>
			</TD>
			<TD>
				<P>Final:</P>
			</TD>
		</TR>
		<TR>
			<TD>
				<P><IMG SRC="images/mealyStep0.png" NAME="Graphic9" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/mealyStep1.png" NAME="Graphic10" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/mealyStep2.png" NAME="Graphic11" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><B>. . . </B>
				</P>
			</TD>
			<TD>
				<P><IMG SRC="images/mealyStep5.png" NAME="Graphic12" ALIGN=BOTTOM BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P>The menu option <B>Input : Fast Run...</B> works similarly, with
the output being displayed in a tape under the input tape: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyFastRun.jpg" NAME="Graphic13" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Fast run output display 
</P>
<P>Similarly, when we select <B>Input : Multiple Run</B>, output is
displayed in the <B>Result</B> column. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyMultipleRun.png" NAME="Graphic14" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Multiple run output display 
</P>
<H3><A NAME="nondeterminism"></A>No Nondeterminism</H3>
<P>As Mealy machines map an input to a unique output, nondeterminism
cannot exist in a Mealy machine. Although we still will be able to
build a Mealy machine that has nondeterminism, we will not be able to
run input on it. 
</P>
<P>For instance, let's modify our machine slightly to make: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyNondeterminism.jpg" NAME="Graphic15" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Mealy machine with nondeterminism 
</P>
<P>We we try to run it on an input, with <B>Input : Step...</B>,
<B>Input : Fast Run...</B>, or <B>Input : Multiple Run...</B>, we
will get an error message asking us to remove the nondeterministic
states: 
</P>
<P ALIGN=CENTER><IMG SRC="images/nondeterminismErrorMessage.png" NAME="Graphic16" ALIGN=BOTTOM BORDER=0>
</P>
<P>Select <B>Test : Highlight Nondeterminism</B> to view the
nondterministic states. Remove the nondeterminism in order to be able
to run input on the Mealy machine. 
</P>
<P><B>This concludes our brief tutorial on Mealy machines. Thanks for
listening!</B> 
</P>
<P>View <A HREF="mealyExamples.html">Mealy machine examples</A>.<BR>View
<A HREF="mooreMachines.html">Moore machines</A>. 
</P>
</BODY>
</HTML>
